﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

// ** WHEN PLATEBODIES ARE IMPLEMENTED - MUST MAKE SHIELDS AND BODIES EQUIPPEDABLE (is that a word?) TOGETHER
public class ArmouryShopButton : MonoBehaviour {

    public PlayerStats stats; // to set the armour
    public int armourNumber;
    public Text armourName;
    public Text description;
    public Text cost;
    public Image imageDisplay;
    private ArmourStats[] armours; // to get access to armour array
    public Money money; // to access and manipulate coin amount
    private int price;
    public Button shopButton; // to access button colours
    private ColorBlock block;

    public bool purchased; // to check if the armour is purchased or not for display reasons
    // ** brute force purchased persistence over scenes. Will continue to try to make this dynamic during the polish stage
    private static bool purchasedWood = true; // default
    private static bool purchasedRound = false;
    private static bool purchasedSpider = false;
    private static bool purchasedStone = false;
    private static bool purchasedEngraved = false;
    private static bool purchasedPlate = false;

    /*
     * BUTTON NAVIGATION IS SET TO NONE - WILL HAVE TO TWEAK IF WE DECIDE ON CONTROLLER IMPLEMENTATION
     * this fixes the button staying on the highlighted colour when clicked, will most likely do the same
     * for the character creation screen.
     */

        
    void Start() {
        stats = GameObject.Find("ShopPlayer").GetComponent<PlayerStats>();
        armours = GameObject.Find("Canvas").GetComponent<ArmourList>().armours;
        price = armours[armourNumber].cost;
        setButton();
        block = new ColorBlock();
        block = shopButton.colors;

        // *** BRUTE FORCE purchased code - hopefully to be changed
        if (armours[armourNumber].armourName == "Wood Shield" && purchasedWood == true) {
            purchased = true;
        }
        else if (armours[armourNumber].armourName == "Round Shield" && purchasedRound == true) {
            purchased = true;
        }
        else if (armours[armourNumber].armourName == "Spider Shield" && purchasedSpider == true) {
            purchased = true;
        }
        if (armours[armourNumber].armourName == "Stone Shield" && purchasedStone == true) {
            purchased = true;
        }
        else if (armours[armourNumber].armourName == "Engraved Stone Shield" && purchasedEngraved == true) {
            purchased = true;
        }
        else if (armours[armourNumber].armourName == "Plate Shield" && purchasedPlate == true) {
            purchased = true;
        }
    }


    // neccesary for colour changes to be in update.
    void Update() {
        // changing on press colors
        if (money.getMoney() >= price || cost.text == "PURCHASED" || cost.text == "EQUIPPED") {
            block.pressedColor = Color.gray;
            shopButton.colors = block;
            if (cost.text == "EQUIPPED") {
                cost.color = Color.green;
            }
            else {
                cost.color = Color.black;
            }
        }
        else {
            block.pressedColor = Color.red; // can't afford = red click
            shopButton.colors = block;
        }

        
        // changing between the cost, "purchased", and "equipped"
        if (stats.getShield().armourName == armours[armourNumber].armourName) {
            cost.text = "EQUIPPED";
        }
        else if (purchased == true) {
            cost.text = "PURCHASED";
        }
        else {
            cost.text = armours[armourNumber].cost.ToString();
        }
        

    }

    // created by following the 'Creating An In-Game Shop' shop tutorial on unity3d.com
    // dynamically allocates the shop buttons based on created armour
    void setButton() {
        armourName.text = armours[armourNumber].armourName;
        description.text = armours[armourNumber].armourDescription;
        imageDisplay.sprite = armours[armourNumber].image;
    }

    public void OnClick() {
        // buying the armour based on currency
        if (money.getMoney() >= price && cost.text != "PURCHASED" && cost.text != "EQUIPPED") {
            money.decreaseCoins(price);
            stats.setShield(armours[armourNumber]); 
            cost.color = Color.green;
            purchased = true;

            // *** BRUTE FORCE purchased code - hopefully to be changed
            if (stats.getShield().armourName == "Wood Shield") {
                purchasedWood = true;
            }
            else if (stats.getShield().armourName == "Round Shield") {
                purchasedRound = true;
            }
            else if (stats.getShield().armourName == "Spider Shield") {
                purchasedSpider = true;
            }
            else if (stats.getShield().armourName == "Stone Shield") {
                purchasedStone = true;
            }
            else if (stats.getShield().armourName == "Engraved Stone Shield") {
                purchasedEngraved = true;
            }
            else if (stats.getShield().armourName == "Plate Shield") {
                purchasedPlate = true;
            }
        }
        else if (cost.text == "PURCHASED") { // already purchased, just equip.
            stats.setShield(armours[armourNumber]);
            cost.text = "EQUIPPED";
        }
        else {
            // will implement sound that the player cannot afford here. (visual handled in update)
        }


    }

    // to display armour stats when you hover over armour buttons
    public void HoverEnter() {
        description.text = "Defense:\n" + armours[armourNumber].defenseBonus;
    }

    // to revert back to the original description
    public void HoverExit() {
        description.text = armours[armourNumber].armourDescription;
    }
    
}
